diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/olsr/model/olsr-state.cc ns-3.40/src/olsr/model/olsr-state.cc
--- ns-3.39/src/olsr/model/olsr-state.cc	2023-07-05 14:23:48.069428200 -0700
+++ ns-3.40/src/olsr/model/olsr-state.cc	2023-09-27 13:30:37.862839700 -0700
@@ -37,7 +37,7 @@
 MprSelectorTuple*
 OlsrState::FindMprSelectorTuple(const Ipv4Address& mainAddr)
 {
-    for (MprSelectorSet::iterator it = m_mprSelectorSet.begin(); it != m_mprSelectorSet.end(); it++)
+    for (auto it = m_mprSelectorSet.begin(); it != m_mprSelectorSet.end(); it++)
     {
         if (it->mainAddr == mainAddr)
         {
@@ -50,7 +50,7 @@
 void
 OlsrState::EraseMprSelectorTuple(const MprSelectorTuple& tuple)
 {
-    for (MprSelectorSet::iterator it = m_mprSelectorSet.begin(); it != m_mprSelectorSet.end(); it++)
+    for (auto it = m_mprSelectorSet.begin(); it != m_mprSelectorSet.end(); it++)
     {
         if (*it == tuple)
         {
@@ -63,7 +63,7 @@
 void
 OlsrState::EraseMprSelectorTuples(const Ipv4Address& mainAddr)
 {
-    for (MprSelectorSet::iterator it = m_mprSelectorSet.begin(); it != m_mprSelectorSet.end();)
+    for (auto it = m_mprSelectorSet.begin(); it != m_mprSelectorSet.end();)
     {
         if (it->mainAddr == mainAddr)
         {
@@ -87,11 +87,9 @@
 {
     std::ostringstream os;
     os << "[";
-    for (MprSelectorSet::const_iterator iter = m_mprSelectorSet.begin();
-         iter != m_mprSelectorSet.end();
-         iter++)
+    for (auto iter = m_mprSelectorSet.begin(); iter != m_mprSelectorSet.end(); iter++)
     {
-        MprSelectorSet::const_iterator next = iter;
+        auto next = iter;
         next++;
         os << iter->mainAddr;
         if (next != m_mprSelectorSet.end())
@@ -108,7 +106,7 @@
 NeighborTuple*
 OlsrState::FindNeighborTuple(const Ipv4Address& mainAddr)
 {
-    for (NeighborSet::iterator it = m_neighborSet.begin(); it != m_neighborSet.end(); it++)
+    for (auto it = m_neighborSet.begin(); it != m_neighborSet.end(); it++)
     {
         if (it->neighborMainAddr == mainAddr)
         {
@@ -121,7 +119,7 @@
 const NeighborTuple*
 OlsrState::FindSymNeighborTuple(const Ipv4Address& mainAddr) const
 {
-    for (NeighborSet::const_iterator it = m_neighborSet.begin(); it != m_neighborSet.end(); it++)
+    for (auto it = m_neighborSet.begin(); it != m_neighborSet.end(); it++)
     {
         if (it->neighborMainAddr == mainAddr && it->status == NeighborTuple::STATUS_SYM)
         {
@@ -134,7 +132,7 @@
 NeighborTuple*
 OlsrState::FindNeighborTuple(const Ipv4Address& mainAddr, Willingness willingness)
 {
-    for (NeighborSet::iterator it = m_neighborSet.begin(); it != m_neighborSet.end(); it++)
+    for (auto it = m_neighborSet.begin(); it != m_neighborSet.end(); it++)
     {
         if (it->neighborMainAddr == mainAddr && it->willingness == willingness)
         {
@@ -147,7 +145,7 @@
 void
 OlsrState::EraseNeighborTuple(const NeighborTuple& tuple)
 {
-    for (NeighborSet::iterator it = m_neighborSet.begin(); it != m_neighborSet.end(); it++)
+    for (auto it = m_neighborSet.begin(); it != m_neighborSet.end(); it++)
     {
         if (*it == tuple)
         {
@@ -160,7 +158,7 @@
 void
 OlsrState::EraseNeighborTuple(const Ipv4Address& mainAddr)
 {
-    for (NeighborSet::iterator it = m_neighborSet.begin(); it != m_neighborSet.end(); it++)
+    for (auto it = m_neighborSet.begin(); it != m_neighborSet.end(); it++)
     {
         if (it->neighborMainAddr == mainAddr)
         {
@@ -173,7 +171,7 @@
 void
 OlsrState::InsertNeighborTuple(const NeighborTuple& tuple)
 {
-    for (NeighborSet::iterator it = m_neighborSet.begin(); it != m_neighborSet.end(); it++)
+    for (auto it = m_neighborSet.begin(); it != m_neighborSet.end(); it++)
     {
         if (it->neighborMainAddr == tuple.neighborMainAddr)
         {
@@ -191,9 +189,7 @@
 OlsrState::FindTwoHopNeighborTuple(const Ipv4Address& neighborMainAddr,
                                    const Ipv4Address& twoHopNeighborAddr)
 {
-    for (TwoHopNeighborSet::iterator it = m_twoHopNeighborSet.begin();
-         it != m_twoHopNeighborSet.end();
-         it++)
+    for (auto it = m_twoHopNeighborSet.begin(); it != m_twoHopNeighborSet.end(); it++)
     {
         if (it->neighborMainAddr == neighborMainAddr &&
             it->twoHopNeighborAddr == twoHopNeighborAddr)
@@ -207,9 +203,7 @@
 void
 OlsrState::EraseTwoHopNeighborTuple(const TwoHopNeighborTuple& tuple)
 {
-    for (TwoHopNeighborSet::iterator it = m_twoHopNeighborSet.begin();
-         it != m_twoHopNeighborSet.end();
-         it++)
+    for (auto it = m_twoHopNeighborSet.begin(); it != m_twoHopNeighborSet.end(); it++)
     {
         if (*it == tuple)
         {
@@ -223,8 +217,7 @@
 OlsrState::EraseTwoHopNeighborTuples(const Ipv4Address& neighborMainAddr,
                                      const Ipv4Address& twoHopNeighborAddr)
 {
-    for (TwoHopNeighborSet::iterator it = m_twoHopNeighborSet.begin();
-         it != m_twoHopNeighborSet.end();)
+    for (auto it = m_twoHopNeighborSet.begin(); it != m_twoHopNeighborSet.end();)
     {
         if (it->neighborMainAddr == neighborMainAddr &&
             it->twoHopNeighborAddr == twoHopNeighborAddr)
@@ -241,8 +234,7 @@
 void
 OlsrState::EraseTwoHopNeighborTuples(const Ipv4Address& neighborMainAddr)
 {
-    for (TwoHopNeighborSet::iterator it = m_twoHopNeighborSet.begin();
-         it != m_twoHopNeighborSet.end();)
+    for (auto it = m_twoHopNeighborSet.begin(); it != m_twoHopNeighborSet.end();)
     {
         if (it->neighborMainAddr == neighborMainAddr)
         {
@@ -266,7 +258,7 @@
 bool
 OlsrState::FindMprAddress(const Ipv4Address& addr)
 {
-    MprSet::iterator it = m_mprSet.find(addr);
+    auto it = m_mprSet.find(addr);
     return (it != m_mprSet.end());
 }
 
@@ -287,7 +279,7 @@
 DuplicateTuple*
 OlsrState::FindDuplicateTuple(const Ipv4Address& addr, uint16_t sequenceNumber)
 {
-    for (DuplicateSet::iterator it = m_duplicateSet.begin(); it != m_duplicateSet.end(); it++)
+    for (auto it = m_duplicateSet.begin(); it != m_duplicateSet.end(); it++)
     {
         if (it->address == addr && it->sequenceNumber == sequenceNumber)
         {
@@ -300,7 +292,7 @@
 void
 OlsrState::EraseDuplicateTuple(const DuplicateTuple& tuple)
 {
-    for (DuplicateSet::iterator it = m_duplicateSet.begin(); it != m_duplicateSet.end(); it++)
+    for (auto it = m_duplicateSet.begin(); it != m_duplicateSet.end(); it++)
     {
         if (*it == tuple)
         {
@@ -321,7 +313,7 @@
 LinkTuple*
 OlsrState::FindLinkTuple(const Ipv4Address& ifaceAddr)
 {
-    for (LinkSet::iterator it = m_linkSet.begin(); it != m_linkSet.end(); it++)
+    for (auto it = m_linkSet.begin(); it != m_linkSet.end(); it++)
     {
         if (it->neighborIfaceAddr == ifaceAddr)
         {
@@ -334,7 +326,7 @@
 LinkTuple*
 OlsrState::FindSymLinkTuple(const Ipv4Address& ifaceAddr, Time now)
 {
-    for (LinkSet::iterator it = m_linkSet.begin(); it != m_linkSet.end(); it++)
+    for (auto it = m_linkSet.begin(); it != m_linkSet.end(); it++)
     {
         if (it->neighborIfaceAddr == ifaceAddr)
         {
@@ -354,7 +346,7 @@
 void
 OlsrState::EraseLinkTuple(const LinkTuple& tuple)
 {
-    for (LinkSet::iterator it = m_linkSet.begin(); it != m_linkSet.end(); it++)
+    for (auto it = m_linkSet.begin(); it != m_linkSet.end(); it++)
     {
         if (*it == tuple)
         {
@@ -376,7 +368,7 @@
 TopologyTuple*
 OlsrState::FindTopologyTuple(const Ipv4Address& destAddr, const Ipv4Address& lastAddr)
 {
-    for (TopologySet::iterator it = m_topologySet.begin(); it != m_topologySet.end(); it++)
+    for (auto it = m_topologySet.begin(); it != m_topologySet.end(); it++)
     {
         if (it->destAddr == destAddr && it->lastAddr == lastAddr)
         {
@@ -389,7 +381,7 @@
 TopologyTuple*
 OlsrState::FindNewerTopologyTuple(const Ipv4Address& lastAddr, uint16_t ansn)
 {
-    for (TopologySet::iterator it = m_topologySet.begin(); it != m_topologySet.end(); it++)
+    for (auto it = m_topologySet.begin(); it != m_topologySet.end(); it++)
     {
         if (it->lastAddr == lastAddr && it->sequenceNumber > ansn)
         {
@@ -402,7 +394,7 @@
 void
 OlsrState::EraseTopologyTuple(const TopologyTuple& tuple)
 {
-    for (TopologySet::iterator it = m_topologySet.begin(); it != m_topologySet.end(); it++)
+    for (auto it = m_topologySet.begin(); it != m_topologySet.end(); it++)
     {
         if (*it == tuple)
         {
@@ -415,7 +407,7 @@
 void
 OlsrState::EraseOlderTopologyTuples(const Ipv4Address& lastAddr, uint16_t ansn)
 {
-    for (TopologySet::iterator it = m_topologySet.begin(); it != m_topologySet.end();)
+    for (auto it = m_topologySet.begin(); it != m_topologySet.end();)
     {
         if (it->lastAddr == lastAddr && it->sequenceNumber < ansn)
         {
@@ -439,7 +431,7 @@
 IfaceAssocTuple*
 OlsrState::FindIfaceAssocTuple(const Ipv4Address& ifaceAddr)
 {
-    for (IfaceAssocSet::iterator it = m_ifaceAssocSet.begin(); it != m_ifaceAssocSet.end(); it++)
+    for (auto it = m_ifaceAssocSet.begin(); it != m_ifaceAssocSet.end(); it++)
     {
         if (it->ifaceAddr == ifaceAddr)
         {
@@ -452,8 +444,7 @@
 const IfaceAssocTuple*
 OlsrState::FindIfaceAssocTuple(const Ipv4Address& ifaceAddr) const
 {
-    for (IfaceAssocSet::const_iterator it = m_ifaceAssocSet.begin(); it != m_ifaceAssocSet.end();
-         it++)
+    for (auto it = m_ifaceAssocSet.begin(); it != m_ifaceAssocSet.end(); it++)
     {
         if (it->ifaceAddr == ifaceAddr)
         {
@@ -466,7 +457,7 @@
 void
 OlsrState::EraseIfaceAssocTuple(const IfaceAssocTuple& tuple)
 {
-    for (IfaceAssocSet::iterator it = m_ifaceAssocSet.begin(); it != m_ifaceAssocSet.end(); it++)
+    for (auto it = m_ifaceAssocSet.begin(); it != m_ifaceAssocSet.end(); it++)
     {
         if (*it == tuple)
         {
@@ -486,8 +477,7 @@
 OlsrState::FindNeighborInterfaces(const Ipv4Address& neighborMainAddr) const
 {
     std::vector<Ipv4Address> retval;
-    for (IfaceAssocSet::const_iterator it = m_ifaceAssocSet.begin(); it != m_ifaceAssocSet.end();
-         it++)
+    for (auto it = m_ifaceAssocSet.begin(); it != m_ifaceAssocSet.end(); it++)
     {
         if (it->mainAddr == neighborMainAddr)
         {
@@ -504,7 +494,7 @@
                                 const Ipv4Address& networkAddr,
                                 const Ipv4Mask& netmask)
 {
-    for (AssociationSet::iterator it = m_associationSet.begin(); it != m_associationSet.end(); it++)
+    for (auto it = m_associationSet.begin(); it != m_associationSet.end(); it++)
     {
         if (it->gatewayAddr == gatewayAddr and it->networkAddr == networkAddr and
             it->netmask == netmask)
@@ -518,7 +508,7 @@
 void
 OlsrState::EraseAssociationTuple(const AssociationTuple& tuple)
 {
-    for (AssociationSet::iterator it = m_associationSet.begin(); it != m_associationSet.end(); it++)
+    for (auto it = m_associationSet.begin(); it != m_associationSet.end(); it++)
     {
         if (*it == tuple)
         {
@@ -537,7 +527,7 @@
 void
 OlsrState::EraseAssociation(const Association& tuple)
 {
-    for (Associations::iterator it = m_associations.begin(); it != m_associations.end(); it++)
+    for (auto it = m_associations.begin(); it != m_associations.end(); it++)
     {
         if (*it == tuple)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/olsr/test/hello-regression-test.cc ns-3.40/src/olsr/test/hello-regression-test.cc
--- ns-3.39/src/olsr/test/hello-regression-test.cc	2023-07-05 14:23:48.069428200 -0700
+++ ns-3.40/src/olsr/test/hello-regression-test.cc	2023-09-27 13:30:37.862839700 -0700
@@ -139,8 +139,7 @@
                               "One Link message on the second and third Hello.");
     }
 
-    std::vector<olsr::MessageHeader::Hello::LinkMessage>::const_iterator iter;
-    for (iter = hello.linkMessages.begin(); iter != hello.linkMessages.end(); iter++)
+    for (auto iter = hello.linkMessages.begin(); iter != hello.linkMessages.end(); iter++)
     {
         if (m_countA == 1)
         {
@@ -193,8 +192,7 @@
                               "One Link message on the second and third Hello.");
     }
 
-    std::vector<olsr::MessageHeader::Hello::LinkMessage>::const_iterator iter;
-    for (iter = hello.linkMessages.begin(); iter != hello.linkMessages.end(); iter++)
+    for (auto iter = hello.linkMessages.begin(); iter != hello.linkMessages.end(); iter++)
     {
         if (m_countA == 1)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/openflow/examples/openflow-switch.cc ns-3.40/src/openflow/examples/openflow-switch.cc
--- ns-3.39/src/openflow/examples/openflow-switch.cc	2023-07-05 14:23:48.069428200 -0700
+++ ns-3.40/src/openflow/examples/openflow-switch.cc	2023-09-27 13:30:37.862839700 -0700
@@ -86,7 +86,6 @@
 int
 main(int argc, char* argv[])
 {
-#ifdef NS3_OPENFLOW
     //
     // Allow the user to override any of the defaults and the above Bind() at
     // run-time, via command-line arguments
@@ -223,9 +222,6 @@
     Simulator::Run();
     Simulator::Destroy();
     NS_LOG_INFO("Done.");
-#else
-    NS_LOG_INFO("NS-3 OpenFlow is not enabled. Cannot run simulation.");
-#endif // NS3_OPENFLOW
 
     return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/openflow/helper/openflow-switch-helper.cc ns-3.40/src/openflow/helper/openflow-switch-helper.cc
--- ns-3.39/src/openflow/helper/openflow-switch-helper.cc	2023-07-05 14:23:48.069428200 -0700
+++ ns-3.40/src/openflow/helper/openflow-switch-helper.cc	2023-09-27 13:30:37.862839700 -0700
@@ -16,7 +16,6 @@
  *
  * Author: Blake Hurd  <naimorai@gmail.com>
  */
-#ifdef NS3_OPENFLOW
 
 #include "openflow-switch-helper.h"
 
@@ -96,5 +95,3 @@
 }
 
 } // namespace ns3
-
-#endif // NS3_OPENFLOW
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/openflow/model/openflow-interface.cc ns-3.40/src/openflow/model/openflow-interface.cc
--- ns-3.39/src/openflow/model/openflow-interface.cc	2023-07-05 14:23:48.069428200 -0700
+++ ns-3.40/src/openflow/model/openflow-interface.cc	2023-09-27 13:30:37.862839700 -0700
@@ -14,7 +14,6 @@
  *
  * Author: Blake Hurd  <naimorai@gmail.com>
  */
-#ifdef NS3_OPENFLOW
 
 #include "openflow-interface.h"
 
@@ -159,7 +158,7 @@
 Stats::FlowStatsInit(const void* body, int body_len, void** state)
 {
     const ofp_flow_stats_request* fsr = (ofp_flow_stats_request*)body;
-    FlowStatsState* s = (FlowStatsState*)xmalloc(sizeof *s);
+    auto s = (FlowStatsState*)xmalloc(sizeof(FlowStatsState));
 
     s->table_idx = fsr->table_id == 0xff ? 0 : fsr->table_id;
     memset(&s->position, 0, sizeof s->position);
@@ -171,7 +170,7 @@
 int
 Stats_FlowDumpCallback(sw_flow* flow, void* state)
 {
-    Stats::FlowStatsState* s = (Stats::FlowStatsState*)state;
+    auto s = (Stats::FlowStatsState*)state;
 
     // Fill Flow Stats
     ofp_flow_stats* ofs;
@@ -326,7 +325,7 @@
 int
 Stats::PortStatsInit(const void* body, int body_len, void** state)
 {
-    PortStatsState* s = (PortStatsState*)xmalloc(sizeof *s);
+    auto s = (PortStatsState*)xmalloc(sizeof(PortStatsState));
 
     // the body contains a list of port numbers
     s->ports = (uint32_t*)xmalloc(body_len);
@@ -879,7 +878,7 @@
         dst_addr.CopyFrom(key.flow.dl_dst);
         if (!dst_addr.IsBroadcast())
         {
-            LearnState_t::iterator st = m_learnState.find(dst_addr);
+            auto st = m_learnState.find(dst_addr);
             if (st != m_learnState.end())
             {
                 out_port = st->second.port;
@@ -916,7 +915,7 @@
         // We can learn a specific port for the source address for future use.
         Mac48Address src_addr;
         src_addr.CopyFrom(key.flow.dl_src);
-        LearnState_t::iterator st = m_learnState.find(src_addr);
+        auto st = m_learnState.find(src_addr);
         if (st == m_learnState.end()) // We haven't learned our source MAC yet.
         {
             LearnedState ls;
@@ -964,7 +963,7 @@
     int prev_port;
     size_t max_len = 0;                   // Initialize to make compiler happy
     uint16_t in_port = key->flow.in_port; // ntohs(key->flow.in_port);
-    uint8_t* p = (uint8_t*)actions;
+    auto p = (uint8_t*)actions;
 
     prev_port = -1;
 
@@ -1023,7 +1022,7 @@
 uint16_t
 ValidateActions(const sw_flow_key* key, const ofp_action_header* actions, size_t actions_len)
 {
-    uint8_t* p = (uint8_t*)actions;
+    auto p = (uint8_t*)actions;
     int err;
 
     while (actions_len >= sizeof(ofp_action_header))
@@ -1089,7 +1088,7 @@
     int prev_port;
     size_t max_len = 0; // Initialize to make compiler happy
     uint16_t in_port = ntohs(key->flow.in_port);
-    uint8_t* p = (uint8_t*)actions;
+    auto p = (uint8_t*)actions;
     uint16_t type;
     ofp_action_output* oa;
 
@@ -1131,7 +1130,7 @@
 uint16_t
 ValidateVPortActions(const ofp_action_header* actions, size_t actions_len)
 {
-    uint8_t* p = (uint8_t*)actions;
+    auto p = (uint8_t*)actions;
     int err;
 
     while (actions_len >= sizeof(ofp_action_header))
@@ -1231,5 +1230,3 @@
 } // namespace ofi
 
 } // namespace ns3
-
-#endif // NS3_OPENFLOW
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/openflow/model/openflow-switch-net-device.cc ns-3.40/src/openflow/model/openflow-switch-net-device.cc
--- ns-3.39/src/openflow/model/openflow-switch-net-device.cc	2023-07-05 14:23:48.069428200 -0700
+++ ns-3.40/src/openflow/model/openflow-switch-net-device.cc	2023-09-27 13:30:37.862839700 -0700
@@ -14,7 +14,6 @@
  *
  * Author: Blake Hurd  <naimorai@gmail.com>
  */
-#ifdef NS3_OPENFLOW
 
 #include "openflow-switch-net-device.h"
 
@@ -28,6 +27,19 @@
 
 NS_OBJECT_ENSURE_REGISTERED(OpenFlowSwitchNetDevice);
 
+/**
+ * Generate an ID.
+ *
+ * \return Generated ID.
+ */
+static uint64_t
+GenerateId()
+{
+    uint8_t ea[ETH_ADDR_LEN];
+    eth_addr_random(ea);
+    return eth_addr_to_uint64(ea);
+}
+
 const char*
 OpenFlowSwitchNetDevice::GetManufacturerDescription()
 {
@@ -52,14 +64,6 @@
     return "N/A";
 }
 
-static uint64_t
-GenerateId()
-{
-    uint8_t ea[ETH_ADDR_LEN];
-    eth_addr_random(ea);
-    return eth_addr_to_uint64(ea);
-}
-
 TypeId
 OpenFlowSwitchNetDevice::GetTypeId()
 {
@@ -133,7 +137,7 @@
 {
     NS_LOG_FUNCTION_NOARGS();
 
-    for (Ports_t::iterator b = m_ports.begin(), e = m_ports.end(); b != e; b++)
+    for (auto b = m_ports.begin(), e = m_ports.end(); b != e; b++)
     {
         SendPortStatus(*b, OFPPR_DELETE);
         b->netdev = nullptr;
@@ -1162,6 +1166,49 @@
 }
 
 int
+OpenFlowSwitchNetDevice::ReceivePortMod(const void* msg)
+{
+    ofp_port_mod* opm = (ofp_port_mod*)msg;
+
+    int port = opm->port_no; // ntohs(opm->port_no);
+    if (port < DP_MAX_PORTS)
+    {
+        ofi::Port& p = m_ports[port];
+
+        // Make sure the port id hasn't changed since this was sent
+        Mac48Address hw_addr = Mac48Address();
+        hw_addr.CopyFrom(opm->hw_addr);
+        if (p.netdev->GetAddress() != hw_addr)
+        {
+            return 0;
+        }
+
+        if (opm->mask)
+        {
+            uint32_t config_mask = ntohl(opm->mask);
+            p.config &= ~config_mask;
+            p.config |= ntohl(opm->config) & config_mask;
+        }
+
+        if (opm->mask & htonl(OFPPC_PORT_DOWN))
+        {
+            if ((opm->config & htonl(OFPPC_PORT_DOWN)) && (p.config & OFPPC_PORT_DOWN) == 0)
+            {
+                p.config |= OFPPC_PORT_DOWN;
+                /// \todo Possibly disable the Port's Net Device via the appropriate interface.
+            }
+            else if ((opm->config & htonl(OFPPC_PORT_DOWN)) == 0 && (p.config & OFPPC_PORT_DOWN))
+            {
+                p.config &= ~OFPPC_PORT_DOWN;
+                /// \todo Possibly enable the Port's Net Device via the appropriate interface.
+            }
+        }
+    }
+
+    return 0;
+}
+
+int
 OpenFlowSwitchNetDevice::ReceiveFeaturesRequest(const void* msg)
 {
     SendFeaturesReply();
@@ -1248,49 +1295,6 @@
     return 0;
 }
 
-int
-OpenFlowSwitchNetDevice::ReceivePortMod(const void* msg)
-{
-    ofp_port_mod* opm = (ofp_port_mod*)msg;
-
-    int port = opm->port_no; // ntohs(opm->port_no);
-    if (port < DP_MAX_PORTS)
-    {
-        ofi::Port& p = m_ports[port];
-
-        // Make sure the port id hasn't changed since this was sent
-        Mac48Address hw_addr = Mac48Address();
-        hw_addr.CopyFrom(opm->hw_addr);
-        if (p.netdev->GetAddress() != hw_addr)
-        {
-            return 0;
-        }
-
-        if (opm->mask)
-        {
-            uint32_t config_mask = ntohl(opm->mask);
-            p.config &= ~config_mask;
-            p.config |= ntohl(opm->config) & config_mask;
-        }
-
-        if (opm->mask & htonl(OFPPC_PORT_DOWN))
-        {
-            if ((opm->config & htonl(OFPPC_PORT_DOWN)) && (p.config & OFPPC_PORT_DOWN) == 0)
-            {
-                p.config |= OFPPC_PORT_DOWN;
-                /// \todo Possibly disable the Port's Net Device via the appropriate interface.
-            }
-            else if ((opm->config & htonl(OFPPC_PORT_DOWN)) == 0 && (p.config & OFPPC_PORT_DOWN))
-            {
-                p.config &= ~OFPPC_PORT_DOWN;
-                /// \todo Possibly enable the Port's Net Device via the appropriate interface.
-            }
-        }
-    }
-
-    return 0;
-}
-
 // add or remove a virtual port table entry
 int
 OpenFlowSwitchNetDevice::ReceiveVPortMod(const void* msg)
@@ -1700,5 +1704,3 @@
 }
 
 } // namespace ns3
-
-#endif // NS3_OPENFLOW
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/openflow/model/openflow-switch-net-device.h ns-3.40/src/openflow/model/openflow-switch-net-device.h
--- ns-3.39/src/openflow/model/openflow-switch-net-device.h	2023-07-05 14:23:48.069428200 -0700
+++ ns-3.40/src/openflow/model/openflow-switch-net-device.h	2023-09-27 13:30:37.862839700 -0700
@@ -503,12 +503,12 @@
      * \param msg The OpenFlow message received.
      * \return 0 if everything's ok, otherwise an error number.
      */
+    int ReceivePortMod(const void* msg);
     int ReceiveFeaturesRequest(const void* msg);
     int ReceiveGetConfigRequest(const void* msg);
     int ReceiveSetConfig(const void* msg);
     int ReceivePacketOut(const void* msg);
     int ReceiveFlow(const void* msg);
-    int ReceivePortMod(const void* msg);
     int ReceiveStatsRequest(const void* msg);
     int ReceiveEchoRequest(const void* msg);
     int ReceiveEchoReply(const void* msg);
@@ -518,7 +518,7 @@
 
     /// Rx Callback
     NetDevice::ReceiveCallback m_rxCallback;
-    /// Promiscuopus Rx Callback
+    /// Promiscuous Rx Callback
     NetDevice::PromiscReceiveCallback m_promiscRxCallback;
 
     Mac48Address m_address;       ///< Address of this device.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/point-to-point/helper/point-to-point-helper.cc ns-3.40/src/point-to-point/helper/point-to-point-helper.cc
--- ns-3.39/src/point-to-point/helper/point-to-point-helper.cc	2023-07-05 14:23:48.069428200 -0700
+++ ns-3.40/src/point-to-point/helper/point-to-point-helper.cc	2023-09-27 13:30:37.862839700 -0700
@@ -82,8 +82,7 @@
     Ptr<PointToPointNetDevice> device = nd->GetObject<PointToPointNetDevice>();
     if (!device)
     {
-        NS_LOG_INFO("PointToPointHelper::EnablePcapInternal(): Device "
-                    << device << " not of type ns3::PointToPointNetDevice");
+        NS_LOG_INFO("Device " << device << " not of type ns3::PointToPointNetDevice");
         return;
     }
 
@@ -117,8 +116,7 @@
     Ptr<PointToPointNetDevice> device = nd->GetObject<PointToPointNetDevice>();
     if (!device)
     {
-        NS_LOG_INFO("PointToPointHelper::EnableAsciiInternal(): Device "
-                    << device << " not of type ns3::PointToPointNetDevice");
+        NS_LOG_INFO("Device " << device << " not of type ns3::PointToPointNetDevice");
         return;
     }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/point-to-point-layout/model/point-to-point-dumbbell.cc ns-3.40/src/point-to-point-layout/model/point-to-point-dumbbell.cc
--- ns-3.39/src/point-to-point-layout/model/point-to-point-dumbbell.cc	2023-07-05 14:23:48.069428200 -0700
+++ ns-3.40/src/point-to-point-layout/model/point-to-point-dumbbell.cc	2023-09-27 13:30:37.862839700 -0700
@@ -17,19 +17,19 @@
 
 // Implement an object to create a dumbbell topology.
 
-#include <cmath>
-#include <iostream>
-#include <sstream>
+#include "point-to-point-dumbbell.h"
 
-// ns3 includes
 #include "ns3/constant-position-mobility-model.h"
 #include "ns3/ipv6-address-generator.h"
 #include "ns3/log.h"
 #include "ns3/node-list.h"
-#include "ns3/point-to-point-dumbbell.h"
 #include "ns3/point-to-point-net-device.h"
 #include "ns3/vector.h"
 
+#include <cmath>
+#include <iostream>
+#include <sstream>
+
 namespace ns3
 {
 
@@ -191,7 +191,7 @@
         ndc.Add(m_leftLeafDevices.Get(i));
         ndc.Add(m_leftRouterDevices.Get(i));
         Ipv6InterfaceContainer ifc = addressHelper.Assign(ndc);
-        Ipv6InterfaceContainer::Iterator it = ifc.Begin();
+        auto it = ifc.Begin();
         m_leftLeafInterfaces6.Add((*it).first, (*it).second);
         it++;
         m_leftRouterInterfaces6.Add((*it).first, (*it).second);
@@ -207,7 +207,7 @@
         ndc.Add(m_rightLeafDevices.Get(i));
         ndc.Add(m_rightRouterDevices.Get(i));
         Ipv6InterfaceContainer ifc = addressHelper.Assign(ndc);
-        Ipv6InterfaceContainer::Iterator it = ifc.Begin();
+        auto it = ifc.Begin();
         m_rightLeafInterfaces6.Add((*it).first, (*it).second);
         it++;
         m_rightRouterInterfaces6.Add((*it).first, (*it).second);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/point-to-point-layout/model/point-to-point-grid.cc ns-3.40/src/point-to-point-layout/model/point-to-point-grid.cc
--- ns-3.39/src/point-to-point-layout/model/point-to-point-grid.cc	2023-07-05 14:23:48.069428200 -0700
+++ ns-3.40/src/point-to-point-layout/model/point-to-point-grid.cc	2023-09-27 13:30:37.862839700 -0700
@@ -17,7 +17,7 @@
 
 // Implement an object to create a grid topology.
 
-#include "ns3/point-to-point-grid.h"
+#include "point-to-point-grid.h"
 
 #include "ns3/constant-position-mobility-model.h"
 #include "ns3/internet-stack-helper.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/point-to-point-layout/model/point-to-point-star.cc ns-3.40/src/point-to-point-layout/model/point-to-point-star.cc
--- ns-3.39/src/point-to-point-layout/model/point-to-point-star.cc	2023-07-05 14:23:48.069428200 -0700
+++ ns-3.40/src/point-to-point-layout/model/point-to-point-star.cc	2023-09-27 13:30:37.862839700 -0700
@@ -15,19 +15,19 @@
 
 // Implement an object to create a star topology.
 
-#include <cmath>
-#include <iostream>
-#include <sstream>
+#include "point-to-point-star.h"
 
-// ns3 includes
 #include "ns3/constant-position-mobility-model.h"
 #include "ns3/ipv6-address-generator.h"
 #include "ns3/log.h"
 #include "ns3/node-list.h"
 #include "ns3/point-to-point-net-device.h"
-#include "ns3/point-to-point-star.h"
 #include "ns3/vector.h"
 
+#include <cmath>
+#include <iostream>
+#include <sstream>
+
 namespace ns3
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/propagation/examples/main-propagation-loss.cc ns-3.40/src/propagation/examples/main-propagation-loss.cc
--- ns-3.39/src/propagation/examples/main-propagation-loss.cc	2023-07-05 14:23:48.069428200 -0700
+++ ns-3.40/src/propagation/examples/main-propagation-loss.cc	2023-09-27 13:30:37.862839700 -0700
@@ -174,7 +174,7 @@
                 Simulator::Run();
             }
 
-            for (rxPowerMapType::const_iterator i = rxPowerMap.begin(); i != rxPowerMap.end(); ++i)
+            for (auto i = rxPowerMap.begin(); i != rxPowerMap.end(); ++i)
             {
                 dataset.Add(distance, i->first, (double)i->second / (double)samples);
             }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/propagation/model/channel-condition-model.h ns-3.40/src/propagation/model/channel-condition-model.h
--- ns-3.39/src/propagation/model/channel-condition-model.h	2023-07-05 14:23:48.069428200 -0700
+++ ns-3.40/src/propagation/model/channel-condition-model.h	2023-09-27 13:30:37.862839700 -0700
@@ -572,7 +572,7 @@
         0}; //!< the threshold for determining what is the ratio of channels with O2I
     double m_o2iLowLossThreshold{0}; //!< the threshold for determining what is the ratio of low -
                                      //!< high O2I building penetration losses
-    double m_linkO2iConditionToAntennaHeight{
+    bool m_linkO2iConditionToAntennaHeight{
         false}; //!< the indicator that determines whether the O2I/O2O condition is determined based
                 //!< on the UE height
     Ptr<UniformRandomVariable> m_uniformVarO2i; //!< uniform random variable that is used for the
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/propagation/model/cost231-propagation-loss-model.cc ns-3.40/src/propagation/model/cost231-propagation-loss-model.cc
--- ns-3.39/src/propagation/model/cost231-propagation-loss-model.cc	2023-07-05 14:23:48.069428200 -0700
+++ ns-3.40/src/propagation/model/cost231-propagation-loss-model.cc	2023-09-27 13:30:37.862839700 -0700
@@ -20,11 +20,12 @@
 
 #include "cost231-propagation-loss-model.h"
 
+#include "propagation-loss-model.h"
+
 #include "ns3/double.h"
 #include "ns3/log.h"
 #include "ns3/mobility-model.h"
 #include "ns3/pointer.h"
-#include "ns3/propagation-loss-model.h"
 
 #include <cmath>
 
@@ -155,20 +156,19 @@
         return 0.0;
     }
 
-    double frequency_MHz = m_frequency * 1e-6;
-
-    double distance_km = distance * 1e-3;
+    double logFrequencyMhz = std::log10(m_frequency * 1e-6);
+    double logDistanceKm = std::log10(distance * 1e-3);
+    double logBSAntennaHeight = std::log10(m_BSAntennaHeight);
 
-    double C_H = 0.8 + ((1.11 * std::log10(frequency_MHz)) - 0.7) * m_SSAntennaHeight -
-                 (1.56 * std::log10(frequency_MHz));
+    double C_H =
+        0.8 + ((1.11 * logFrequencyMhz) - 0.7) * m_SSAntennaHeight - (1.56 * logFrequencyMhz);
 
     // from the COST231 wiki entry
     // See also http://www.lx.it.pt/cost231/final_report.htm
     // Ch. 4, eq. 4.4.3, pg. 135
 
-    double loss_in_db =
-        46.3 + (33.9 * std::log10(frequency_MHz)) - (13.82 * std::log10(m_BSAntennaHeight)) - C_H +
-        ((44.9 - 6.55 * std::log10(m_BSAntennaHeight)) * std::log10(distance_km)) + m_shadowing;
+    double loss_in_db = 46.3 + (33.9 * logFrequencyMhz) - (13.82 * logBSAntennaHeight) - C_H +
+                        ((44.9 - 6.55 * logBSAntennaHeight) * logDistanceKm) + m_shadowing;
 
     NS_LOG_DEBUG("dist =" << distance << ", Path Loss = " << loss_in_db);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/propagation/model/cost231-propagation-loss-model.h ns-3.40/src/propagation/model/cost231-propagation-loss-model.h
--- ns-3.39/src/propagation/model/cost231-propagation-loss-model.h	2023-07-05 14:23:48.069428200 -0700
+++ ns-3.40/src/propagation/model/cost231-propagation-loss-model.h	2023-09-27 13:30:37.866839600 -0700
@@ -21,8 +21,9 @@
 #ifndef COST231_PROPAGATION_LOSS_MODEL_H
 #define COST231_PROPAGATION_LOSS_MODEL_H
 
+#include "propagation-loss-model.h"
+
 #include "ns3/nstime.h"
-#include "ns3/propagation-loss-model.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/propagation/model/itu-r-1411-los-propagation-loss-model.h ns-3.40/src/propagation/model/itu-r-1411-los-propagation-loss-model.h
--- ns-3.39/src/propagation/model/itu-r-1411-los-propagation-loss-model.h	2023-07-05 14:23:48.069428200 -0700
+++ ns-3.40/src/propagation/model/itu-r-1411-los-propagation-loss-model.h	2023-09-27 13:30:37.866839600 -0700
@@ -22,7 +22,7 @@
 #ifndef ITU_R_1411_LOS_PROPAGATION_LOSS_MODEL_H
 #define ITU_R_1411_LOS_PROPAGATION_LOSS_MODEL_H
 
-#include "ns3/propagation-loss-model.h"
+#include "propagation-loss-model.h"
 
 namespace ns3
 {
